#include "posTestWin.h"
#include "ui_posTestWin.h"
#include <QPushButton>
#include <qDebug>

PosTestWin::PosTestWin(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::PosTestWin)
{
    ui->setupUi(this);

    ui->gpbRdTest->setVisible(false);
    ui->gpbRnTest->setVisible(true);
    ui->gpbRnSignal->setVisible(false);

    rnModel = new QStandardItemModel(this);
    rnSelect = new QItemSelectionModel(rnModel);
    rnModel->setColumnCount(10);
    ui->tableViewRn->setModel(rnModel);
    ui->tableViewRn->setSelectionModel(rnSelect);
    ui->tableViewRn->horizontalHeader()->setVisible(false);
    ui->tableViewRn->verticalHeader()->setVisible(false);
    //ui->tableViewRn->horizontalHeader()->setStretchLastSection(true);
    ui->tableViewRn->horizontalHeader()->setSectionResizeMode(QHeaderView::Stretch);
    ui->tableViewRn->verticalHeader()->setSectionResizeMode(QHeaderView::Stretch);
    ui->tableViewRn->setWordWrap(true);


    rdModel = new QStandardItemModel(this);
    rdSelect = new QItemSelectionModel(rdModel);
    rdModel->setColumnCount(6);
    ui->tableViewRd->setModel(rdModel);
    ui->tableViewRd->setSelectionModel(rdSelect);
    ui->tableViewRd->horizontalHeader()->setVisible(false);
    ui->tableViewRd->verticalHeader()->setVisible(false);
    //ui->tableViewRn->horizontalHeader()->setStretchLastSection(true);
    ui->tableViewRd->horizontalHeader()->setSectionResizeMode(QHeaderView::Stretch);
    ui->tableViewRd->verticalHeader()->setSectionResizeMode(QHeaderView::Stretch);
    ui->tableViewRd->setWordWrap(true);

    QFont font = ui->tableViewRn->font();
    font.setBold(true);
    QFont smallFont = font;
    smallFont.setPointSize(font.pointSize()-2);
    smallFont.setBold(false);

    QList<QStandardItem *> aItemList;
    for(int r=0;r<9;r++){
        aItemList.clear();
        for(int c=0;c<11;c++){
            QStandardItem *aItem = new QStandardItem("");
            aItem->setTextAlignment(Qt::AlignCenter);
            aItem->setFont(smallFont);
            aItemList.append(aItem);
        }
        rnModel->insertRow(rnModel->rowCount(),aItemList);
        ui->tableViewRn->setSpan(r,0,1,2);
    }

    for(int r=0;r<6;r++){
        aItemList.clear();
        for(int c=0;c<6;c++){
            QStandardItem *aItem = new QStandardItem("");
            aItem->setTextAlignment(Qt::AlignCenter);
            aItem->setFont(smallFont);
            aItemList.append(aItem);
        }
        rdModel->insertRow(rdModel->rowCount(),aItemList);
        ui->tableViewRd->setSpan(r,0,1,2);
    }

    rnModel->item(0,0)->setText("定位模式");
    rnModel->item(0,0)->setFont(font);
    ui->tableViewRn->setSpan(0,0,2,2);

    smallFont.setPointSize(font.pointSize()-1);
    smallFont.setBold(true);
    QPushButton *b1cBtn = new QPushButton("B1频点C码定位");
    b1cBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    b1cBtn->setFont(smallFont);
    b1cBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(2,0),b1cBtn);

    QPushButton *b3cBtn = new QPushButton("B3频点C码定位");
    b3cBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    b3cBtn->setFont(smallFont);
    b3cBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(3,0),b3cBtn);

    QPushButton *b1b3cBtn = new QPushButton("B1+B3频点C码定位");
    b1b3cBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    b1b3cBtn->setFont(smallFont);
    b1b3cBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(4,0),b1b3cBtn);

    QPushButton *gpsBtn = new QPushButton("GPS频点C码定位");
    gpsBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    gpsBtn->setFont(smallFont);
    gpsBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(5,0),gpsBtn);

    QPushButton *b1pBtn = new QPushButton("B1频点P码定位");
    b1pBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    b1pBtn->setFont(smallFont);
    b1pBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(6,0),b1pBtn);

    QPushButton *b3pBtn = new QPushButton("B3频点P码定位");
    b3pBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    b3pBtn->setFont(smallFont);
    b3pBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(7,0),b3pBtn);

    QPushButton *compatibleBtn = new QPushButton("兼容定位");
    compatibleBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    compatibleBtn->setFont(smallFont);
    compatibleBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(8,0),compatibleBtn);

    rnModel->item(0,2)->setText("定位结果");
    rnModel->item(0,2)->setFont(font);
    ui->tableViewRn->setSpan(0,2,1,7);

    rnModel->item(1,2)->setText("时间");
    rnModel->item(1,2)->setFont(font);

    rnModel->item(1,3)->setText("经度");
    rnModel->item(1,3)->setFont(font);

    rnModel->item(1,4)->setText("纬度");
    rnModel->item(1,4)->setFont(font);

    rnModel->item(1,5)->setText("高程");
    rnModel->item(1,5)->setFont(font);

    rnModel->item(1,6)->setText("PDOP");
    rnModel->item(1,6)->setFont(font);

    rnModel->item(1,7)->setText("VDOP");
    rnModel->item(1,7)->setFont(font);

    rnModel->item(1,8)->setText("HDOP");
    rnModel->item(1,8)->setFont(font);

    rnModel->item(0,9)->setText("卫星状态");
    rnModel->item(0,9)->setFont(font);
    ui->tableViewRn->setSpan(0,9,1,2);

    rnModel->item(1,9)->setText("有效卫星");
    rnModel->item(1,9)->setFont(font);

    rnModel->item(1,10)->setText("信号");
    rnModel->item(1,10)->setFont(font);

    QPushButton *viewB1CBtn = new QPushButton("查看");
    viewB1CBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewB1CBtn->setFont(smallFont);
    viewB1CBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(2,10),viewB1CBtn);
    connect(viewB1CBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    QPushButton *viewB3CBtn = new QPushButton("查看");
    viewB3CBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewB3CBtn->setFont(smallFont);
    viewB3CBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(3,10),viewB3CBtn);
    connect(viewB3CBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    QPushButton *viewB1B3CBtn = new QPushButton("查看");
    viewB1B3CBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewB1B3CBtn->setFont(smallFont);
    viewB1B3CBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(4,10),viewB1B3CBtn);
    connect(viewB1B3CBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    QPushButton *viewGPSBtn = new QPushButton("查看");
    viewGPSBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewGPSBtn->setFont(smallFont);
    viewGPSBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(5,10),viewGPSBtn);
    connect(viewGPSBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    QPushButton *viewB1PBtn = new QPushButton("查看");
    viewB1PBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewB1PBtn->setFont(smallFont);
    viewB1PBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(6,10),viewB1PBtn);
    connect(viewB1PBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    QPushButton *viewB3PBtn = new QPushButton("查看");
    viewB3PBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewB3PBtn->setFont(smallFont);
    viewB3PBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(7,10),viewB3PBtn);
    connect(viewB3PBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    QPushButton *viewCompatibleBtn = new QPushButton("查看");
    viewCompatibleBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    viewCompatibleBtn->setFont(smallFont);
    viewCompatibleBtn->setDefault(true);
    ui->tableViewRn->setIndexWidget(rnModel->index(8,10),viewCompatibleBtn);
    connect(viewCompatibleBtn,SIGNAL(clicked()),this,SLOT(view_signal_clicked()),Qt::QueuedConnection);

    rdModel->item(0,0)->setText("定位模式");
    rdModel->item(0,0)->setFont(font);
    ui->tableViewRd->setSpan(0,0,2,2);

    QPushButton *rdPosBtn = new QPushButton("RDSS单次定位");
    rdPosBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    rdPosBtn->setFont(font);
    rdPosBtn->setDefault(true);
    ui->tableViewRd->setIndexWidget(rdModel->index(2,0),rdPosBtn);

    QPushButton *rdContinuePosBtn = new QPushButton("RDSS连续定位");
    rdContinuePosBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    rdContinuePosBtn->setFont(font);
    rdContinuePosBtn->setDefault(true);
    ui->tableViewRd->setIndexWidget(rdModel->index(3,0),rdContinuePosBtn);

    QPushButton *rdEmergencyPosBtn = new QPushButton("RDSS紧急定位");
    rdEmergencyPosBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    rdEmergencyPosBtn->setFont(font);
    rdEmergencyPosBtn->setDefault(true);
    ui->tableViewRd->setIndexWidget(rdModel->index(4,0),rdEmergencyPosBtn);

    QPushButton *rdStopContinuePosBtn = new QPushButton("结束RDSS连续定位");
    rdStopContinuePosBtn->setSizePolicy(QSizePolicy::Preferred,QSizePolicy::Preferred);
    rdStopContinuePosBtn->setFont(font);
    rdStopContinuePosBtn->setDefault(true);
    ui->tableViewRd->setIndexWidget(rdModel->index(5,0),rdStopContinuePosBtn);

    rdModel->item(0,2)->setText("定位结果");
    rdModel->item(0,2)->setFont(font);
    ui->tableViewRd->setSpan(0,2,1,4);

    rdModel->item(1,2)->setText("时间");
    rdModel->item(1,2)->setFont(font);

    rdModel->item(1,3)->setText("经度");
    rdModel->item(1,3)->setFont(font);

    rdModel->item(1,4)->setText("纬度");
    rdModel->item(1,4)->setFont(font);

    rdModel->item(1,5)->setText("高程");
    rdModel->item(1,5)->setFont(font);
}

PosTestWin::~PosTestWin()
{
    delete ui;
}

void PosTestWin::on_btnRdTest_clicked()
{
    ui->gpbRdTest->setVisible(true);
    ui->gpbRnTest->setVisible(false);
    ui->gpbRnSignal->setVisible(false);
}


void PosTestWin::on_btnRnTest_clicked()
{
    ui->gpbRdTest->setVisible(false);
    ui->gpbRnTest->setVisible(true);
    ui->gpbRnSignal->setVisible(false);
}

void PosTestWin::view_signal_clicked()
{
    ui->gpbRdTest->setVisible(false);
    ui->gpbRnTest->setVisible(false);
    ui->gpbRnSignal->setVisible(true);
}

