﻿#ifndef SQLITEDB_H
#define SQLITEDB_H

#include <QtSql>
#include <QThread>
#include <QObject>

class SQLITEDB: public QObject
{
    Q_OBJECT
private:
    SQLITEDB(QObject *parent = nullptr);
    ~SQLITEDB();
    SQLITEDB(const SQLITEDB&);
    SQLITEDB& operator=(const SQLITEDB&);
    QSqlDatabase  DB; //数据库
    QThread *thread;
public:
    static SQLITEDB& getInstance()
    {
        static SQLITEDB instance;
        return instance;
    }
    void openDateBase();
    void closeDateBase();
    QSqlDatabase &getDateBase();
    bool tableExist(const QString &table);
    bool keyExist(const QString &table,const QString &key);
    bool createKey(const QString &table,const QString &key, const QString &type);
    bool createTable(const QString &sql);
    QStringList getPrimaryKeys(const QString &table);
    QStringList getTableFields(const QString &table);
    QStringList getTableNames();
    QVector<QMap<QString,QString>> getRecord(const QString &table,const QMap<QString,QString> &condition);
    bool saveRecord(const QString &table,const QMap<QString,QString> &map);

};

#endif // SQLITEDB_H
