#ifndef STATUSTESTWIN_H
#define STATUSTESTWIN_H

#include <QWidget>
#include <QStandardItemModel>
#include <QItemSelectionModel>

namespace Ui {
class StatusTestWin;
}

class StatusTestWin : public QWidget
{
    Q_OBJECT

public:
    explicit StatusTestWin(QWidget *parent = nullptr);
    ~StatusTestWin();

signals:
    void writeDataSignal(const QByteArray &buf);

private slots:
    void readRnSnHandle();
    void readRdSnHandle();
    void readMPD7IdHandle();
    void readPrmIdHandle();
    void readMPD7DateHandle();
    void readPrmDateHandle();
    void recvSbxHandle(const QString &cmd);
    void recvIciHandle(const QString &cmd);
    void recvPidHandle(const QString &cmd);
    void recvIidHandle(const QString &cmd);
    void recvIcmHandle(const QString &cmd);
    void recvPmuHandle(const QString &cmd);

private:
    Ui::StatusTestWin *ui;
    QStandardItemModel *statusModel;
    QItemSelectionModel *statusSelect;
};

#endif // STATUSTESTWIN_H
