#ifndef TESTTHREAD_H
#define TESTTHREAD_H

#include <QThread>

typedef enum {
    SERIAL = 0,
    CAN,
}TEST_TYPE;

class TestThread : public QThread
{
    Q_OBJECT
public:
    static TestThread& getInstance()
    {
        static TestThread instance;
        return instance;
    }
    bool setTestList(const QVector<TEST_TYPE> &list);
    void stopTest();
    bool isOnTest();
private:
    TestThread();
    ~TestThread();
    TestThread(const TestThread&);
    TestThread& operator=(const TestThread&);

signals:
    void writeDataSignal(const QByteArray &buf);
    void serialRecvResultSignal(bool result);
    void serialSendResultSignal(bool result);
    void curTestInfoSignal(const QString &item,int timeCounts);

private slots:
    void receiverSerialDataHandle(const QByteArray &data);

protected:
    void run() override;

private:
    QVector<TEST_TYPE> testList;
    bool onTest = false;
    bool quit = false;
    QByteArray unprocessData;
};

#endif // TESTTHREAD_H
